using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Sample.Presentation;

namespace Sample.Win.UI
{
    public partial class PersonForm : Form,IPersonView
    {
        private PersonPresenter presenter;
        
        public PersonForm()
        {
            InitializeComponent();
            HookupEventHandlers();
            presenter = new PersonPresenter(this);            
        }

        private void HookupEventHandlers()
        {
            this.submitButton.Click += delegate
                                           {
                                               presenter.Submit();
                                           };
        }

        public string FirstName
        {
            get { return this.firstNameTextBox.Text; }
        }

        public string LastName
        {
            get { return this.lastNameTextBox.Text; }
        }

        public string Address
        {
            get { return this.addressTextBox.Text; }
        }

        public string Age
        {
            get { return this.ageTextBox.Text; }
        }

        public void DisplayErrors(IList<string> messages)
        {
            StringBuilder builder = new StringBuilder();
            foreach (string message in messages)
            {
                builder.AppendLine(message);
            }
            MessageBox.Show(builder.ToString());
        }

        public void DisplaySuccess()
        {
            MessageBox.Show("Success");
        }
    }
}